#include "f2c.h"
#include "fio.h"
#include "lio.h"

extern flag lquit;
extern int lcount;
extern char *icptr;
extern char *icend;
extern icilist *svic;
extern int icnum, recpos;

int i_getc(Void)
{
	if(recpos >= svic->icirlen) {
		if (recpos++ == svic->icirlen)
			return '\n';
		z_rnew();
		}
	recpos++;
	if(icptr >= icend) err(svic->iciend,(EOF),"endfile");
	return(*icptr++);
	}

#ifdef KR_headers
int i_ungetc(ch, f) int ch; FILE *f;
#else
int i_ungetc(int ch, FILE *f)
#endif
{
	if (--recpos == svic->icirlen)
		return '\n';
	if (recpos < -1)
		err(svic->icierr,110,"recend");
	/* *--icptr == ch, and icptr may point to read-only memory */
	return *--icptr /* = ch */;
	}

 static void
#ifdef KR_headers
c_lir(a) icilist *a;
#else
c_lir(icilist *a)
#endif
{
	extern int l_eof;
	reading = 1;
	external = 0;
	formatted = 1;
	svic = a;
	L_len = a->icirlen;
	recpos = -1;
	icnum = recpos = 0;
	cursor = 0;
	l_getc = i_getc;
	l_ungetc = i_ungetc;
	l_eof = 0;
	icptr = a->iciunit;
	icend = icptr + a->icirlen*a->icirnum;
	cf = 0;
	curunit = 0;
	elist = (cilist *)a;
	}


#ifdef KR_headers
integer s_rsli(a) icilist *a;
#else
integer s_rsli(icilist *a)
#endif
{
	lioproc = l_read;
	lquit = 0;
	lcount = 0;
	c_lir(a);
	return(0);
	}

integer e_rsli(Void)
{ return 0; }

#ifdef KR_headers
s_rsni(a) icilist *a;
#else
extern int x_rsne(cilist*);

s_rsni(icilist *a)
#endif
{
	cilist ca;
	ca.ciend = a->iciend;
	ca.cierr = a->icierr;
	ca.cifmt = a->icifmt;
	c_lir(a);
	return x_rsne(&ca);
	}
